;WARNING!!! RESULTS ARE PRELIMINARY. DO NOT PUBLISH OR PRESENT THESE RESULTS 
;WITHOUT FIRST CONSULTING THE EFW PI JOHN WYGANT <wygan001@umn.edu>

;rbsp_efw_vxb_subtract_crib
;
;Creates vxB subtracted tplot variables
;****NOTE: FOR BETTER EFW DATA CONSIDER USING rbsp_efw_spinfit_vxb_subtract_crib.pro
;
;requires: THEMIS TDAS software
;			 http://themis.ssl.berkeley.edu/software.shtml
;		   as well as SPICE software
;
;Created by Aaron Breneman, UMN, Dec 2012
;			email: awbrenem@gmail.com



;Corotation test dates
;A
;	2012-10-13 -> much better



;initialize RBSP environment
	rbsp_efw_init
	!rbsp_efw.user_agent = ''


;set desired probe
	probe = 'b'
	rbspx = 'rbsp'+probe

;set time of interest to a single day
	date = '2012-10-13'	; UTC.
	duration = 1	; days.
	timespan, date, duration


;Set other quantities
	integration=0 ; for looking at integration data
	get_support_data = 0 ; include support data? 0=no, 1=yes
	suffix = ''
	spinperiod = 11. ;seconds	
	type='calibrated' ;use ADC (raw) numbers or physical (calibrated) units?



;Load definitive sc positions and velocities
	rbsp_load_spice_kernels




;Load EMFISIS data in GSE.  
	rbsp_load_emfisis,probe=probe,coord='gse',cadence='4sec',level='l3'  



;Downsample data to spinperiod
	rbsp_downsample,[rbspx+'_emfisis_l3_4sec_gse_Mag',$
					 rbspx+'_emfisis_l3_4sec_gse_Magnitude'],$
					 1/spinperiod,/nochange





;Load Esvy data in MGSE 
	rbsp_load_efw_esvy_mgse,probe=probe,/no_spice_load
	rbsp_downsample,rbspx+'_efw_esvy_mgse',1/spinperiod,/nochange
	
	

;load position and velocity data
	rbsp_load_spice_state,probe=probe,coord='gse',/no_spice_load  





;Get spin-axis pointing direction once/minute
	time2=time_double(date) ; first get unix time double for beginning of day

	;number of time chunks throughout day
	ntimes = 1440.  ;1440 = once/min
	time3 = time_string(time2 + 60.*indgen(ntimes))

	strput,time3,'T',10 ; convert TPLOT time string 'yyyy-mm-dd/hh:mm:ss.msec' to ISO 'yyyy-mm-ddThh:mm:ss.msec'
	cspice_str2et,time3,et2 ; convert ISO time string to SPICE ET

	cspice_pxform,'RBSP'+strupcase(probe)+'_SCIENCE','GSE',et2,pxform

	wsc=dblarr(3,ntimes)
	wsc[2,*]=1d
	wsc_GSE=dblarr(3,ntimes)

	for qq=0l,ntimes-1 do begin wsc_GSE[*,qq] = pxform[*,*,qq] ## wsc[*,qq]




	
		
		
;Now convert from GSE to MGSE. 

	;put the pointing direction on the same timestamps as the Efield data

	get_data,'rbsp'+probe+'_emfisis_l3_4sec_gse_Mag',data=tmpp
	wsc_GSE_tmp = [[interpol(wsc_GSE[0,*],time_double(time3),tmpp.x)],$
  				   [interpol(wsc_GSE[1,*],time_double(time3),tmpp.x)],$
				   [interpol(wsc_GSE[2,*],time_double(time3),tmpp.x)]]
	rbsp_gse2mgse,'rbsp'+probe+'_emfisis_l3_4sec_gse_Mag',wsc_GSE_tmp,newname='rbsp'+probe+'_mag_mgse'



	get_data,'rbsp'+probe+'_state_vel_gse',data=tmpp
	wsc_GSE_tmp = [[interpol(wsc_GSE[0,*],time_double(time3),tmpp.x)],$
  				   [interpol(wsc_GSE[1,*],time_double(time3),tmpp.x)],$
				   [interpol(wsc_GSE[2,*],time_double(time3),tmpp.x)]]
	rbsp_gse2mgse,'rbsp'+probe+'_state_vel_gse',wsc_GSE_tmp,newname='rbsp'+probe+'_vel_mgse'



; Load eclipse times 
	rbsp_load_eclipse_predict,probe,date
	get_data,'rbsp'+probe+'_umbra',data=eu
	get_data,'rbsp'+probe+'_penumbra',data=ep







;Create the vxB subtracted variables
	
	rbsp_vxb_subtract,'rbsp'+probe+'_vel_mgse','rbsp'+probe+'_mag_mgse','rbsp'+probe+'_efw_esvy_mgse'

	get_data,'Esvy_mgse_vxb_removed',data=dat,dlimits=dlim,limits=lim
	store_data,'rbsp'+probe+'_esvy_mgse_vxb_removed',data=dat,dlimits=dlim,limits=lim
	options,'rbsp'+probe+'_esvy_mgse_vxb_removed','colors',[2,4,6]




;Determine corotation Efield
	rbsp_corotation_efield,probe,date,/no_spice_load


;Remove corotation Efield
	dif_data,rbspx+'_esvy_mgse_vxb_removed',rbspx+'_E_coro_mgse',newname=rbspx+'_esvy_mgse_vxb_removed'



	split_vec,rbspx+'_esvy_mgse_vxb_removed'
	split_vec,rbspx+'_efw_esvy_mgse'
	
	

	options,rbspx+'_esvy_mgse_vxb_removed_x','ytitle','Ex!CMGSE!Cvxb!Cremoved!C[mV/m]'
	options,rbspx+'_esvy_mgse_vxb_removed_y','ytitle','Ey!CMGSE!Cvxb!Cremoved!C[mV/m]'
	options,rbspx+'_esvy_mgse_vxb_removed_z','ytitle','Ez!CMGSE!Cvxb!Cremoved!C[mV/m]'

	options,rbspx+'_efw_esvy_mgse_x','ytitle','Ex!CMGSE!C[mV/m]'
	options,rbspx+'_efw_esvy_mgse_y','ytitle','Ey!CMGSE!C[mV/m]'
	options,rbspx+'_efw_esvy_mgse_z','ytitle','Ez!CMGSE!C[mV/m]'

	options,rbspx + ['_efw_esvy_mgse_x',$
			 '_efw_esvy_mgse_y',$
			 '_efw_esvy_mgse_z',$
			 '_esvy_mgse_vxb_removed_x',$
			 '_esvy_mgse_vxb_removed_y',$
			 '_esvy_mgse_vxb_removed_z'],'labflag',-1

	options,rbspx+'_esvy_mgse_vxb_removed_x','labels','X MGSE'
	options,rbspx+'_esvy_mgse_vxb_removed_y','labels','Y MGSE'
	options,rbspx+'_esvy_mgse_vxb_removed_z','labels','Z MGSE'
	options,rbspx+'_efw_esvy_mgse_x','labels','X MGSE'
	options,rbspx+'_efw_esvy_mgse_y','labels','Y MGSE'
	options,rbspx+'_efw_esvy_mgse_z','labels','Z MGSE'



	options,rbspx+'_efw_esvy_mgse','ysubtitle',''
	options,rbspx+'_efw_esvy_mgse_x','ysubtitle',''
	options,rbspx+'_efw_esvy_mgse_y','ysubtitle',''
	options,rbspx+'_efw_esvy_mgse_z','ysubtitle',''





	tplot_options,'xmargin',[20.,15.]
	tplot_options,'ymargin',[3,6]
	tplot_options,'xticklen',0.08
	tplot_options,'yticklen',0.02
	tplot_options,'xthick',2
	tplot_options,'ythick',2
	tplot_options,'labflag',-1	




	ylim,[rbspx+'_esvy_mgse_vxb_removed_x',$
		   rbspx+'_esvy_mgse_vxb_removed_y',$
		   rbspx+'_esvy_mgse_vxb_removed_z',$
		   rbspx+'_efw_esvy_mgse_x',$
		   rbspx+'_efw_esvy_mgse_y',$
		   rbspx+'_efw_esvy_mgse_z'],-300,300



	tplot_options,'title','Esvy compared to!CEsvy with vxB removed'
	tplot,[rbspx+'_esvy_mgse_vxb_removed_y',$
		   rbspx+'_esvy_mgse_vxb_removed_z',$
		   rbspx+'_efw_esvy_mgse_y',$
		   rbspx+'_efw_esvy_mgse_z'],$
		   var_label = var_label

	;eclipse times
	if is_struct(eu) then timebar,eu.x,color=50
	if is_struct(eu) then timebar,eu.x + eu.y,color=50
	if is_struct(ep) then timebar,ep.x,color=80
	if is_struct(ep) then timebar,ep.x + ep.y,color=80



;zoomed-in plot

	ylim,[rbspx+'_esvy_mgse_vxb_removed_y',$
		   rbspx+'_esvy_mgse_vxb_removed_z',$
		   rbspx+'_efw_esvy_mgse_y',$
		   rbspx+'_efw_esvy_mgse_z'],-30,30



	tplot_options,'title','Esvy compared to!CEsvy with vxB removed'
	tplot,[rbspx+'_esvy_mgse_vxb_removed_y',$
		   rbspx+'_esvy_mgse_vxb_removed_z',$
		   rbspx+'_efw_esvy_mgse_y',$
		   rbspx+'_efw_esvy_mgse_z'],$
		   var_label = var_label

	;eclipse times
	if is_struct(eu) then timebar,eu.x,color=50
	if is_struct(eu) then timebar,eu.x + eu.y,color=50
	if is_struct(ep) then timebar,ep.x,color=80
	if is_struct(ep) then timebar,ep.x + ep.y,color=80




end
